unit Unit1;

interface

uses
  SysUtils, Types, Classes, Variants, Graphics, Forms, Dialogs,
  IdUDPServer, IdBaseComponent, IdComponent, IdUDPBase, IdUDPClient,
  idSocketHandle, QExtCtrls, QStdCtrls, QControls;

type
  TForm1 = class(TForm)
    IdUDPClient1: TIdUDPClient;
    IdUDPServer1: TIdUDPServer;
    Panel1: TPanel;
    Memo1: TMemo;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure IdUDPServer1UDPRead(Sender: TObject; AData: TStream;
      ABinding: TIdSocketHandle);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
 IdUDPClient1.Send(Edit1.Text);
end;

procedure TForm1.IdUDPServer1UDPRead(Sender: TObject; AData: TStream;
  ABinding: TIdSocketHandle);
var
  StringFormatedStream: TStringStream;
  s: String;
begin
 StringFormatedStream := TStringStream.Create('');

 StringFormatedStream.CopyFrom(AData, AData.Size);
 Memo1.Lines.Add(ABinding.PeerIP+' '+StringFormatedStream.DataString);
 ABinding.SendTo(ABinding.PeerIP, ABinding.PeerPort, s[1], Length(s));
 StringFormatedStream.Free;
end;

end.
